
"******************************************************************************"
"USER CONFIGURABLE SECTION"

        channelNumberString := self currentApplication channel asString.
        collectorNumberString := self currentApplication collectorNumber asString.
        facilityName := self currentApplication hookFacilityName.
        hostname := self currentApplication hostname.
        dataRootPath := self currentApplication rootDirectory.
        facilityLabel := (PROVISO.PvInstallerCollectorBasedConfiguration allSubclasses detect:[:aClass| aClass facilityName = facilityName] ifNone:[]) facilityLabel.
"*******************************************************************************"
"INITIALIZE"
        registry :=
                PROVISO.PvConfigurationDBRegistry
                        fromRegistryNamed: 'DATALOAD'
                        withCreation: true.

"******************************************************************************"
"REMOVE"

        registry keys asArray do:
                [:key |
                | subparts |
                subparts := key findToken: $..
                ('DATALOAD.' , collectorNumberString , '.DATACHANNEL') = key
                        ifTrue: [       | currentCount |
                                        registry unsetAt: (subparts at: 2) , '.' , subparts last.
                                        currentCount := registry numberAt: 'COMMON.COUNT'  ifAbsent: [ 0 ] .
                                        (currentCount > 0)
                                                ifTrue:
                                                        [ registry
                                                                setAt: 'COMMON.COUNT'
                                                                numberValue: (currentCount - 1)
                                                                withCreation: true]].

                ('DATALOAD.' , collectorNumberString , '.CREATION_DATE') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.PRODUCT_LABEL') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.PRODUCT_TYPE') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.VERSION') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.HOST') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.INSTALL_DIRECTORY') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.PORT') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.DATA_ROOT_DIRECTORY') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ('DATALOAD.' , collectorNumberString , '.DESCRIPTION') = key
                        ifTrue: [ registry unsetAt: (subparts at: 2), '.' , subparts last].

                ].

"***************************************************************"
"ADD"

        "If this entry already exists, do nothing, otherwise, increment the common count"
        (registry
                numberAt: collectorNumberString , '.DATACHANNEL'
                ifAbsent: [nil]) isNil
                        ifTrue:
                                [| currentCount |
                                currentCount :=
                                        registry
                                                numberAt: 'COMMON.COUNT'
                                                ifAbsent: [0].
                                registry
                                        setAt: 'COMMON.COUNT'
                                        numberValue: currentCount + 1
                                        withCreation: true].
        registry
                setAt: collectorNumberString , '.CREATION_DATE'
                        stringValue: self timeFacade now asString
                        withCreation: true;
                setAt: collectorNumberString , '.PRODUCT_LABEL'
                        stringValue: facilityLabel
                        withCreation: true;
                setAt: collectorNumberString , '.PRODUCT_TYPE'
                        stringValue: facilityName
                        withCreation: true;
                setAt: collectorNumberString , '.VERSION'
                        stringValue: Object pvReleaseLabel , '  ' , Object pvVersionString
                        withCreation: true;
                setAt: collectorNumberString , '.HOST'
                        stringValue: hostname
                        withCreation: true;
                setAt: collectorNumberString , '.INSTALL_DIRECTORY'
                        stringValue: './'
                        withCreation: true;
                setAt: collectorNumberString , '.PORT'
                        numberValue: 0 asNumber
                        withCreation: true;
                setAt: collectorNumberString , '.DATACHANNEL'
                        numberValue: channelNumberString asNumber
                        withCreation: true;
                setAt: collectorNumberString , '.DATA_ROOT_DIRECTORY'
                        stringValue: dataRootPath
                        withCreation: true;
                setAt: collectorNumberString , '.DESCRIPTION'
                        stringValue:
                                'PROVISO Bulk Collector #' , collectorNumberString ,
                                        ' on ' , hostname
                        withCreation: true
